import nose

from joblib._utils import eval_expr


def test_eval_expr_invalid():
    cases = [
        "exec('import os')", "print(1)", "import os", "1+1; import os", "1^1"
    ]
    for expr in cases:
        with nose.tools.assert_raises(ValueError) as ar:
            eval_expr(expr)
        nose.tools.assert_in(
            "is not a valid or supported arithmetic", str(ar.exception)
        )


def test_eval_expr_valid():
    cases = [
        ("2*6", 12),
        ("2**6", 64),
        ("1 + 2*3**(4) / (6 + -7)", -161.0),
        ("(20 // 3) % 5", 1),
    ]
    for expr, result in cases:
        nose.tools.assert_equal(eval_expr(expr), result)
